1 # SPDX-License-Identifier: GPL-2.0+
5 MIRROR_DOCKER: docker.io
11 # Grab our configured image. The source for this is found
12 # in the u-boot tree at tools/docker/Dockerfile
13 image: ${MIRROR_DOCKER}/trini/u-boot-gitlab-ci-runner:jammy-20240125-12Feb2024
15 # We run some tests in different order, to catch some failures quicker.
21 .buildman_and_testpy_template: &buildman_and_testpy_dfn
23 retry: 2 # QEMU may be too slow, etc.
27 # Clone uboot-test-hooks
28 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
29 - git clone --depth=1 https://source.denx.de/u-boot/u-boot-test-hooks /tmp/uboot-test-hooks
30 - ln -s travis-ci /tmp/uboot-test-hooks/bin/`hostname`
31 - ln -s travis-ci /tmp/uboot-test-hooks/py/`hostname`
32 - grub-mkimage --prefix="" -o ~/grub_x86.efi -O i386-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
33 - grub-mkimage --prefix="" -o ~/grub_x64.efi -O x86_64-efi normal echo lsefimmap lsefi lsefisystab efinet tftp minicmd
34 - if [[ "${TEST_PY_BD}" == "qemu-riscv32_spl" ]]; then
35 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.3.1/opensbi-1.3.1-rv-bin.tar.xz | tar -C /tmp -xJ;
36 export OPENSBI=/tmp/opensbi-1.3.1-rv-bin/share/opensbi/ilp32/generic/firmware/fw_dynamic.bin;
38 - if [[ "${TEST_PY_BD}" == "qemu-riscv64_spl" ]] || [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
39 wget -O - https://github.com/riscv-software-src/opensbi/releases/download/v1.3.1/opensbi-1.3.1-rv-bin.tar.xz | tar -C /tmp -xJ;
40 export OPENSBI=/tmp/opensbi-1.3.1-rv-bin/share/opensbi/lp64/generic/firmware/fw_dynamic.bin;
44 - cp -v /tmp/${TEST_PY_BD}/*.{html,css} .
45 - rm -rf /tmp/uboot-test-hooks /tmp/venv
47 # If we've been asked to use clang only do one configuration.
48 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/${TEST_PY_BD}
49 - echo BUILD_ENV ${BUILD_ENV}
50 - if [ -n "${BUILD_ENV}" ]; then
53 - tools/buildman/buildman -o ${UBOOT_TRAVIS_BUILD_DIR} -w -E -W -e
54 --board ${TEST_PY_BD} ${OVERRIDE}
55 - cp ~/grub_x86.efi $UBOOT_TRAVIS_BUILD_DIR/
56 - cp ~/grub_x64.efi $UBOOT_TRAVIS_BUILD_DIR/
57 - cp /opt/grub/grubriscv64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_riscv64.efi
58 - cp /opt/grub/grubaa64.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm64.efi
59 - cp /opt/grub/grubarm.efi $UBOOT_TRAVIS_BUILD_DIR/grub_arm.efi
60 # create sdcard / spi-nor images for sifive unleashed using genimage
61 - if [[ "${TEST_PY_BD}" == "sifive_unleashed" ]]; then
63 cp ${UBOOT_TRAVIS_BUILD_DIR}/spl/u-boot-spl.bin .;
64 cp ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.itb .;
66 genimage --inputpath . --config board/sifive/unleashed/genimage_sdcard.cfg;
67 cp images/sdcard.img ${UBOOT_TRAVIS_BUILD_DIR}/;
69 genimage --inputpath . --config board/sifive/unleashed/genimage_spi-nor.cfg;
70 cp images/spi-nor.img ${UBOOT_TRAVIS_BUILD_DIR}/;
72 - if [[ "${TEST_PY_BD}" == "coreboot" ]]; then
73 cp /opt/coreboot/coreboot.rom ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom;
74 /opt/coreboot/cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom remove -n fallback/payload;
75 /opt/coreboot/cbfstool ${UBOOT_TRAVIS_BUILD_DIR}/coreboot.rom add-flat-binary -f ${UBOOT_TRAVIS_BUILD_DIR}/u-boot.bin -n fallback/payload -c LZMA -l 0x1110000 -e 0x1110000;
77 - virtualenv -p /usr/bin/python3 /tmp/venv
78 - . /tmp/venv/bin/activate
79 - pip install -r test/py/requirements.txt
80 # "${var:+"-k $var"}" expands to "" if $var is empty, "-k $var" if not
81 - export PATH=/opt/qemu/bin:/tmp/uboot-test-hooks/bin:${PATH};
82 export PYTHONPATH=/tmp/uboot-test-hooks/py/travis-ci;
83 ./test/py/test.py -ra --bd ${TEST_PY_BD} ${TEST_PY_ID}
84 ${TEST_PY_TEST_SPEC:+"-k ${TEST_PY_TEST_SPEC}"}
85 --build-dir "$UBOOT_TRAVIS_BUILD_DIR"
98 build all 32bit ARM platforms:
102 git config --global --add safe.directory "${CI_PROJECT_DIR}";
103 pip install -r tools/buildman/requirements.txt;
104 ./tools/buildman/buildman -o /tmp -PEWM arm -x aarch64 || ret=$?;
105 if [[ $ret -ne 0 ]]; then
106 ./tools/buildman/buildman -o /tmp -seP;
110 build all 64bit ARM platforms:
111 extends: .world_build
113 - virtualenv -p /usr/bin/python3 /tmp/venv
114 - . /tmp/venv/bin/activate
116 git config --global --add safe.directory "${CI_PROJECT_DIR}";
117 pip install -r tools/buildman/requirements.txt;
118 ./tools/buildman/buildman -o /tmp -PEWM aarch64 || ret=$?;
119 if [[ $ret -ne 0 ]]; then
120 ./tools/buildman/buildman -o /tmp -seP;
124 build all PowerPC platforms:
125 extends: .world_build
128 git config --global --add safe.directory "${CI_PROJECT_DIR}";
129 ./tools/buildman/buildman -o /tmp -P -E -W powerpc || ret=$?;
130 if [[ $ret -ne 0 ]]; then
131 ./tools/buildman/buildman -o /tmp -seP;
135 build all other platforms:
136 extends: .world_build
139 git config --global --add safe.directory "${CI_PROJECT_DIR}";
140 ./tools/buildman/buildman -o /tmp -PEWM -x arm,powerpc || ret=$?;
141 if [[ $ret -ne 0 ]]; then
142 ./tools/buildman/buildman -o /tmp -seP;
151 check for new CONFIG symbols outside Kconfig:
154 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
155 # If grep succeeds and finds a match the test fails as we should
157 - git grep -E '^#[[:blank:]]*(define|undef)[[:blank:]]*CONFIG_'
158 :^doc/ :^arch/arm/dts/ :^scripts/kconfig/lkc.h
159 :^include/linux/kconfig.h :^tools/ && exit 1 || exit 0
161 # build documentation
165 - virtualenv -p /usr/bin/python3 /tmp/venvhtml
166 - . /tmp/venvhtml/bin/activate
167 - pip install -r doc/sphinx/requirements.txt
168 - make htmldocs KDOC_WERROR=1
171 # ensure all configs have MAINTAINERS entries
172 Check for configs without MAINTAINERS entry:
175 - ./tools/buildman/buildman --maintainer-check
177 # Ensure host tools build
178 Build tools-only and envtools:
181 - make tools-only_config tools-only -j$(nproc);
183 make tools-only_config envtools -j$(nproc)
185 Run binman, buildman, dtoc, Kconfig and patman testsuites:
188 - git config --global user.name "GitLab CI Runner";
190 git config --global --add safe.directory "${CI_PROJECT_DIR}";
192 virtualenv -p /usr/bin/python3 /tmp/venv;
193 . /tmp/venv/bin/activate;
194 pip install -r test/py/requirements.txt;
195 pip install -r tools/buildman/requirements.txt;
196 export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only;
197 export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt";
198 export PATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc:${PATH}";
200 ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
203 ./tools/binman/binman --toolpath ${UBOOT_TRAVIS_BUILD_DIR}/tools test;
204 ./tools/buildman/buildman -t;
205 ./tools/dtoc/dtoc -t;
206 ./tools/patman/patman test;
209 # Check for any pylint regressions
213 - git config --global --add safe.directory "${CI_PROJECT_DIR}"
214 - pip install -r test/py/requirements.txt
215 - pip install -r tools/buildman/requirements.txt
216 - pip install asteval pylint==2.12.2 pyopenssl
217 - export PATH=${PATH}:~/.local/bin
218 - echo "[MASTER]" >> .pylintrc
219 - echo "load-plugins=pylint.extensions.docparams" >> .pylintrc
220 - export UBOOT_TRAVIS_BUILD_DIR=/tmp/tools-only
222 - ./tools/buildman/buildman -T0 -o ${UBOOT_TRAVIS_BUILD_DIR} -w
226 - export PYTHONPATH="${UBOOT_TRAVIS_BUILD_DIR}/scripts/dtc/pylibfdt"
229 # Check for pre-schema driver model tags
230 Check for pre-schema tags:
233 - git config --global --add safe.directory "${CI_PROJECT_DIR}";
234 # If grep succeeds and finds a match the test fails as we should
236 - git grep u-boot,dm- -- '*.dts*' && exit 1 || exit 0
238 # Check we can package the Python tools
239 Check packing of Python tools:
244 # Test sandbox with test.py
247 TEST_PY_BD: "sandbox"
248 <<: *buildman_and_testpy_dfn
250 sandbox with clang test.py:
252 TEST_PY_BD: "sandbox"
253 OVERRIDE: "-O clang-16"
254 <<: *buildman_and_testpy_dfn
258 TEST_PY_BD: "sandbox64"
259 <<: *buildman_and_testpy_dfn
261 sandbox64 with clang test.py:
263 TEST_PY_BD: "sandbox64"
264 OVERRIDE: "-O clang-16"
265 <<: *buildman_and_testpy_dfn
269 TEST_PY_BD: "sandbox_spl"
270 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
271 <<: *buildman_and_testpy_dfn
273 sandbox_noinst_test.py:
275 TEST_PY_BD: "sandbox_noinst"
276 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
277 <<: *buildman_and_testpy_dfn
279 sandbox_noinst with LOAD_FIT_FULL test.py:
281 TEST_PY_BD: "sandbox_noinst"
282 TEST_PY_TEST_SPEC: "test_ofplatdata or test_handoff or test_spl"
283 OVERRIDE: "-a CONFIG_SPL_LOAD_FIT_FULL=y"
284 <<: *buildman_and_testpy_dfn
288 TEST_PY_BD: "sandbox_vpl"
289 TEST_PY_TEST_SPEC: "vpl or test_spl"
290 <<: *buildman_and_testpy_dfn
292 # Enable tracing and disable LTO, to ensure functions are not elided
293 sandbox trace_test.py:
295 TEST_PY_BD: "sandbox"
296 BUILD_ENV: "FTRACE=1 NO_LTO=1"
297 TEST_PY_TEST_SPEC: "trace"
298 OVERRIDE: "-a CONFIG_TRACE=y -a CONFIG_TRACE_EARLY=y -a CONFIG_TRACE_EARLY_SIZE=0x01000000 -a CONFIG_TRACE_BUFFER_SIZE=0x02000000"
299 <<: *buildman_and_testpy_dfn
303 TEST_PY_BD: "evb-ast2500"
304 TEST_PY_ID: "--id qemu"
305 <<: *buildman_and_testpy_dfn
309 TEST_PY_BD: "evb-ast2600"
310 TEST_PY_ID: "--id qemu"
311 <<: *buildman_and_testpy_dfn
313 sandbox_flattree test.py:
315 TEST_PY_BD: "sandbox_flattree"
316 <<: *buildman_and_testpy_dfn
318 vexpress_ca9x4 test.py:
320 TEST_PY_BD: "vexpress_ca9x4"
321 TEST_PY_ID: "--id qemu"
322 <<: *buildman_and_testpy_dfn
324 integratorcp_cm926ejs test.py:
326 TEST_PY_BD: "integratorcp_cm926ejs"
327 TEST_PY_TEST_SPEC: "not sleep"
328 TEST_PY_ID: "--id qemu"
329 <<: *buildman_and_testpy_dfn
333 TEST_PY_BD: "qemu_arm"
334 TEST_PY_TEST_SPEC: "not sleep"
335 <<: *buildman_and_testpy_dfn
339 TEST_PY_BD: "qemu_arm64"
340 TEST_PY_TEST_SPEC: "not sleep"
341 <<: *buildman_and_testpy_dfn
345 TEST_PY_BD: "M5208EVBE"
346 TEST_PY_ID: "--id qemu"
347 TEST_PY_TEST_SPEC: "not sleep and not efi"
348 OVERRIDE: "-a CONFIG_M68K_QEMU=y -a ~CONFIG_MCFTMR"
349 <<: *buildman_and_testpy_dfn
354 TEST_PY_TEST_SPEC: "not sleep and not efi"
355 TEST_PY_ID: "--id qemu"
356 <<: *buildman_and_testpy_dfn
358 qemu_maltael test.py:
360 TEST_PY_BD: "maltael"
361 TEST_PY_TEST_SPEC: "not sleep and not efi"
362 TEST_PY_ID: "--id qemu"
363 <<: *buildman_and_testpy_dfn
365 qemu_malta64 test.py:
367 TEST_PY_BD: "malta64"
368 TEST_PY_TEST_SPEC: "not sleep and not efi"
369 TEST_PY_ID: "--id qemu"
370 <<: *buildman_and_testpy_dfn
372 qemu_malta64el test.py:
374 TEST_PY_BD: "malta64el"
375 TEST_PY_TEST_SPEC: "not sleep and not efi"
376 TEST_PY_ID: "--id qemu"
377 <<: *buildman_and_testpy_dfn
379 qemu-ppce500 test.py:
381 TEST_PY_BD: "qemu-ppce500"
382 TEST_PY_TEST_SPEC: "not sleep"
383 <<: *buildman_and_testpy_dfn
385 qemu-riscv32 test.py:
387 TEST_PY_BD: "qemu-riscv32"
388 TEST_PY_TEST_SPEC: "not sleep"
389 <<: *buildman_and_testpy_dfn
391 qemu-riscv64 test.py:
393 TEST_PY_BD: "qemu-riscv64"
394 TEST_PY_TEST_SPEC: "not sleep"
395 <<: *buildman_and_testpy_dfn
397 qemu-riscv32_spl test.py:
399 TEST_PY_BD: "qemu-riscv32_spl"
400 TEST_PY_TEST_SPEC: "not sleep"
401 <<: *buildman_and_testpy_dfn
403 qemu-riscv64_spl test.py:
405 TEST_PY_BD: "qemu-riscv64_spl"
406 TEST_PY_TEST_SPEC: "not sleep"
407 <<: *buildman_and_testpy_dfn
411 TEST_PY_BD: "qemu-x86"
412 TEST_PY_TEST_SPEC: "not sleep"
413 <<: *buildman_and_testpy_dfn
417 TEST_PY_BD: "qemu-x86_64"
418 TEST_PY_TEST_SPEC: "not sleep"
419 <<: *buildman_and_testpy_dfn
421 r2dplus_i82557c test.py:
423 TEST_PY_BD: "r2dplus"
424 TEST_PY_ID: "--id i82557c_qemu"
425 <<: *buildman_and_testpy_dfn
427 r2dplus_pcnet test.py:
429 TEST_PY_BD: "r2dplus"
430 TEST_PY_ID: "--id pcnet_qemu"
431 <<: *buildman_and_testpy_dfn
433 r2dplus_rtl8139 test.py:
435 TEST_PY_BD: "r2dplus"
436 TEST_PY_ID: "--id rtl8139_qemu"
437 <<: *buildman_and_testpy_dfn
439 r2dplus_tulip test.py:
441 TEST_PY_BD: "r2dplus"
442 TEST_PY_ID: "--id tulip_qemu"
443 <<: *buildman_and_testpy_dfn
445 sifive_unleashed_sdcard test.py:
447 TEST_PY_BD: "sifive_unleashed"
448 TEST_PY_ID: "--id sdcard_qemu"
449 <<: *buildman_and_testpy_dfn
451 sifive_unleashed_spi-nor test.py:
453 TEST_PY_BD: "sifive_unleashed"
454 TEST_PY_ID: "--id spi-nor_qemu"
455 <<: *buildman_and_testpy_dfn
457 xilinx_zynq_virt test.py:
459 TEST_PY_BD: "xilinx_zynq_virt"
460 TEST_PY_TEST_SPEC: "not sleep"
461 TEST_PY_ID: "--id qemu"
462 <<: *buildman_and_testpy_dfn
464 xilinx_versal_virt test.py:
466 TEST_PY_BD: "xilinx_versal_virt"
467 TEST_PY_TEST_SPEC: "not sleep"
468 TEST_PY_ID: "--id qemu"
469 <<: *buildman_and_testpy_dfn
474 TEST_PY_TEST_SPEC: "not sleep"
475 TEST_PY_ID: "--id qemu"
476 <<: *buildman_and_testpy_dfn
480 TEST_PY_BD: "coreboot"
481 TEST_PY_TEST_SPEC: "not sleep"
482 TEST_PY_ID: "--id qemu"
483 <<: *buildman_and_testpy_dfn